# Write your code here :-)
import board, time, neopixel, digitalio, busio
import adafruit_lis3dh
import touchio
from adafruit_apds9960.apds9960 import APDS9960
from audiopwmio import PWMAudioOut as AudioOut
from audiocore import WaveFile
from adafruit_debouncer import Debouncer

pixels_pin=board.NEOPIXEL
pixels_num_of_lights=10
pixels=neopixel.NeoPixel(pixels_pin,pixels_num_of_lights,brightness=0.5, auto_write=True)
# create buttons
button_A_input = digitalio.DigitalInOut(board.BUTTON_A)
button_A_input.switch_to_input(pull=digitalio.Pull.DOWN)
button_A = Debouncer(button_A_input)
button_B_input = digitalio.DigitalInOut(board.BUTTON_B)
button_B_input.switch_to_input(pull=digitalio.Pull.DOWN)
button_B = Debouncer(button_B_input)

speaker = digitalio.DigitalInOut(board.SPEAKER_ENABLE)
speaker.direction = digitalio.Direction.OUTPUT
speaker.value = True
audio = AudioOut(board.SPEAKER)
path = "sounds/"

def play_sound(filename):
    with open(path+ filename,"rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing:
            pass


i2c = busio.I2C(board.ACCELEROMETER_SCL, board.ACCELEROMETER_SDA)
int1 = digitalio.DigitalInOut(board.ACCELEROMETER_INTERRUPT)
accelerometer = adafruit_lis3dh.LIS3DH_I2C(i2c, address=0x19, int1=int1)
accelerometer.range = adafruit_lis3dh.RANGE_8_G

pad = [board.A1, board.A2, board.A3,board.A4]
touchpad = []
for i in range(len(pad)):
    touchpad.append(touchio.TouchIn(pad[i]))

strip_pin=board.TX
strip_num_of_lights=30
strip=neopixel.NeoPixel(strip_pin,strip_num_of_lights,brightness=0.5, auto_write=True)

RED = (255,0,0)
BLACK = (0,0,0)
GREEN = (0,255,0)

guess = ""
code = "1234"

def password():
    global guess
    global code
    if len(guess) < 4:
        time.sleep(1)
        if touchpad[0].value:
            play_sound("1.wav")
            guess = guess + "1"
            password()
        elif touchpad[1].value:
            play_sound("2.wav")
            guess = guess + "2"
            password()
        elif touchpad[2].value:
            play_sound("3.wav")
            guess = guess + "3"
            password()
        elif touchpad[3].value:
            play_sound("4.wav")
            guess = guess + "4"
            password
    else:
        if guess == code:
            strip.fill(GREEN)
            play_sound("wand.wav")
            print("OPEN BOX")
            guess = ""
        else:
            strip.fill(RED)
            print("incorrect code, Try again")
            play_sound("siren.wav")
            guess = ""
            password()


armed = False
pixels.fill(BLACK)
strip.fill(BLACK)
while True:
    button_A.update()
    button_B.update()
    x,y,z = accelerometer.acceleration
    if button_A.fell:
        speaker.value = False
        print("Alarm set")
        armed = True
        strip.fill(BLACK)
        pixels.fill(BLACK)
        time.sleep(2)
    elif button_B.value:
        armed=False
        pixels.fill(BLACK)
        print("INSERT THE CODE")
        time.sleep(1)
        password()
    elif x > 0.6 and y > 0.65 and armed:
        speaker.value = True
        strip.fill(RED)
        pixels.fill(RED)
        play_sound("siren.wav")

